/********************************************************************************************************
 * @file     common.c
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2016, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/
#define _COMMON_C_


/* ------------------------------------
    Header Files
   ------------------------------------ */

#include "common.h"


/* ------------------------------------
    Macro Definitions
   ------------------------------------ */


/* ------------------------------------
    Type Definitions
   ------------------------------------ */


/* ------------------------------------
    Variables Definitions
   ------------------------------------ */
homkit_flash_parameter_layout_def   homkit_flash_parameter_layout;

u8 led_val[6] = { PMW_MAX_TICK_BASE, PMW_MAX_TICK_BASE, PMW_MAX_TICK_BASE, PMW_MAX_TICK_BASE, PMW_MAX_TICK_BASE, PMW_MAX_TICK_BASE };
u8 light_onoff_status = 1;

/* ------------------------------------
    Function Prototypes
   ------------------------------------ */
void COMMON_Init (void)
{
    homkit_flash_parameter_layout.flash_adr_mac_111 = (volatile u8 *)(FLASH_ADR_MAC);
    homkit_flash_parameter_layout.flash_adr_setupcode_111 = (volatile u8 *)(FLASH_ADR_SETUPCODE);
    //homkit_flash_parameter_layout.flash_adr_pairing_111 = (volatile u8 *)(FLASH_ADR_PAIRING);
    homkit_flash_parameter_layout.flash_adr_hash_id_111 = (volatile u8 *)(FLASH_ADR_HASH_ID);
    homkit_flash_parameter_layout.flash_adr_setup_id_111 = (volatile u8 *)(FLASH_ADR_SETUP_ID);
    homkit_flash_parameter_layout.flash_adr_srpkey2_111 = (volatile u8 *)(FLASH_ADR_SRP_KEY2);
	homkit_flash_parameter_layout.flash_adr_srpkey2_crc_111 = (volatile u8 *)(FLASH_ADR_SRP_KEY2_CRC_DATA);

}

void pwm_set_lum(int id, u8 y, int pol) {
    int lum = (y) * PMW_MAX_TICK_MULTI;
    pwm_set_cmp(id, pol ? PMW_MAX_TICK - lum : lum);
}

void pwm_light_enable(u8 on) {
    if (on) {
        light_onoff_status = 1;
        pwm_set_lum(PWMID_R, led_val[0], 0);
        pwm_set_lum(PWMID_G, led_val[1], 0);
        pwm_set_lum(PWMID_B, led_val[2], 0);
        pwm_set_lum(PWMID_W, led_val[3], 0);
    } else {
        light_onoff_status = 0;
        pwm_set_lum(PWMID_R, 0, 0);
        pwm_set_lum(PWMID_G, 0, 0);
        pwm_set_lum(PWMID_B, 0, 0);
        pwm_set_lum(PWMID_W, 0, 0);
    }
}

void rf_led_ota_ok(void) {
    gpio_set_func(OTA_LED, AS_GPIO);
    gpio_set_output_en(OTA_LED, 1);
    static u8 led_onoff = 0;
    foreach(i, 6)
    {
    	if(blc_ll_getCurrentState() == BLS_LINK_STATE_ADV)
    	{
    		u8 r = irq_disable ();
    	}
        gpio_write(OTA_LED, led_onoff);
        led_onoff = !led_onoff;
        sleep_us(1000 * 1000);
    }
}

void rf_led_ota_error(void) {
    gpio_set_func(OTA_LED, AS_GPIO);
    gpio_set_output_en(OTA_LED, 1);
    static u8 led_onoff = 0;
    foreach(i, 60)
    {
    	if(blc_ll_getCurrentState() == BLS_LINK_STATE_ADV)
    	{
    		u8 r = irq_disable ();
    	}
        gpio_write(OTA_LED, led_onoff);
        led_onoff = !led_onoff;
        sleep_us(100 * 1000);
    }
}


/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
